// EEPROM driver

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

#include "main.h"
#include "eeprom.h"

//----- functions ----------------------------------------      
unsigned char EEPROM_get(auto int addr) {                                  
	EECON1bits.EEPGD = 0;
	EECON1bits.CFGS = 0;  
	EEADR = addr;          
	EECON1bits.RD = 1;     
	return EEDATA;  
}
//--------------------------------------------------------
	
void EEPROM_put(auto int addr, auto unsigned char data) { 
	EECON1bits.EEPGD = 0;  
	EECON1bits.CFGS = 0;  
	EECON1bits.WREN = 1;   
	EEADR = addr;          
	EEDATA = data;        
	INTCONbits.GIE = 1; // Disable interrupts
	EECON2 = 0x55;         
	EECON2 = 0xAA;         
	EECON1bits.WR = 1;     
	INTCONbits.GIE = 0; // Enable interrupts
	while (!PIR2bits.EEIF);
	PIR2bits.EEIF = 0;     
	EECON1bits.WREN = 0;   
}
//--------------------------------------------------------

int EEPROM_get_int(auto int addr) {
 	return (int)EEPROM_get(addr) | ( ( (int)EEPROM_get(addr+1) )<<8 );
}
//--------------------------------------------------------

void EEPROM_put_int(auto int addr, auto int data) {
	EEPROM_put(addr, data);	
	EEPROM_put(addr+1, data>>8 );	
}

