// EEPROM_SPI driver

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

#ifndef EEPROMspi_h
#define EEPROMspi_h

//----- defines ------------------------------------------
#define EESPIRd     0b00000011
#define EESPIWr     0b00000010
#define EESPIWrEn   0b00000110
#define EESPIWrDi   0b00000100
#define EESPIRdSR   0b00000101
#define EESPIWrSR   0b00000001
#define EESPIErAll  0b11000111
#define EESPIErSect 0b11011000

      
typedef struct {
	unsigned char page;
	unsigned long addr;   
	unsigned char adrbus;		
} eedata_Write ;   
      
//----- user defines ------------------------------------------       

#define EEPspiA16 	16	// AdrBus=16bit
#define EEPspiA24 	24	// AdrBus=24bit

#define EEPspiRead	0
#define EEPspiWrite	128

//----- functions ----------------------------------------
void				eepspi_init(void);
void 				eepspi_open (eedata_Write *wr_desc, unsigned long addr, unsigned char adrbus);
void 				eepspi_close(void);
void 				eepspi_erase(void);
void 				eepspi_read (unsigned char *p, unsigned int num);
void 				eepspi_write(unsigned char *p, unsigned int num);
#define        eepspi_get() spi_read()   // returns unsigned char
void 				eepspi_put  (unsigned char c);
unsigned int	eepspi_gets (unsigned char *p, unsigned int num);
unsigned int	eepspi_puts (unsigned char *p);

//--------------------------------------------------------
#endif
