// MCP6SX driver

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

#include "main.h"
#include "spi_mc.h"
#include "mcp6sx.h"

rom spi_datastruct mcp6sx_desc=
{&PORTE, &DDRE, MODE_00, SPI_SLOW , 0x02, 0x01, SMPMID };//bit 1

//----- functions ----------------------------------------
void 	mcp6sx_init(void) {
	PORTEbits.RE1=1; // normally high
	DDREbits.RE1=0;  // PORTE bit 1 = output
	
	mcp6sx_set(0,0);
}
//--------------------------------------------------------

void 	mcp6sx_set(unsigned char ch, unsigned char f) {
	if(!spi_open(&mcp6sx_desc) ) return;	
	spi_write(MCP6SX_WRITE2REG | MCP6SX_GAIN); 
	spi_write(f);	
	spi_close();

	spi_open(&mcp6sx_desc);	
	spi_write(MCP6SX_WRITE2REG | MCP6SX_CHANNEL); 
	spi_write(ch);	
	spi_close();
	
	Delay10KTCYx(8u);
	/*
	ch=100;	
	do {
		f=250;
		do{
			f--;
		} while (f != 0u);
		ch--;
	} while (ch != 0u);
	*/
}
//--------------------------------------------------------

