// andi.c

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

#include "main.h"
#include <adc.h>
#include "andi.h"

//----- functions ----------------------------------------
void 				Andi_init(void) {
	// total_time=15tad
	OpenADC(  ADC_FOSC_64 & ADC_RIGHT_JUST & ADC_4_TAD
				,ADC_CH0 & ADC_INT_OFF & ADC_VREFPLUS_EXT & ADC_VREFMINUS_VSS
				,ANDI_INPUTS &15 );
}
//--------------------------------------------------------

void 				Andi_setup(unsigned char adcfosc) {
	// total_time=13tad
	OpenADC(  adcfosc & ADC_LEFT_JUST & ADC_2_TAD
				,ADC_CH1 & ADC_INT_OFF & ADC_VREFPLUS_EXT & ADC_VREFMINUS_VSS
				,ANDI_INPUTS  &15);
}
//--------------------------------------------------------

unsigned char	Andi_high(unsigned char ch) {
	// total_time=31tad
	OpenADC(  ADC_FOSC_64 & ADC_LEFT_JUST & ADC_20_TAD
				,ADC_CH1 & ADC_INT_OFF & ADC_VREFPLUS_EXT & ADC_VREFMINUS_VSS
				,ANDI_INPUTS  &15 );
	SetChanADC(ch);	
	ANDI_GO;	
	while( ANDI_BUSY );
//	CloseADC();
	return ADRESH;
}
//--------------------------------------------------------

unsigned int	Andi_int(unsigned char ch) {
	// total_time=31tad	
	OpenADC(  ADC_FOSC_64 & ADC_RIGHT_JUST & ADC_20_TAD
				,ADC_CH1 & ADC_INT_OFF & ADC_VREFPLUS_EXT & ADC_VREFMINUS_VSS
//				,ADC_CH0 & ADC_INT_OFF & ADC_VREFPLUS_VDD & ADC_VREFMINUS_VSS
				,ANDI_INPUTS &15); // 11
	SetChanADC(ch);
	ANDI_GO;
	while( ANDI_BUSY );
//	CloseADC();
	return ReadADC();
}
//--------------------------------------------------------


