// draw.c

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

#include "main.h"
#include <stdlib.h>
#include "draw.h"
#include "sampl.h"
#include "sci.h"
#include "i2str.h"
#include "eeprom.h"


//----- external variables -------------------------------

unsigned char draw_t0;
unsigned char draw_td;
unsigned char draw_u0;
unsigned char draw_ud;
unsigned char draw_tds;
unsigned char draw_uds;
unsigned char draw_show;

//rom const char draw_vline[]={32, 166, 32, 166, 32, 166, 32, 166, 0};
//                            step, start
//rom const int  draw_scale[]={ 30, 16};	// 200us 1 30
//rom const int  draw_scale[]={ 75, 31};	// 500us 2 75
//rom const int  draw_scale[]={150, 106};	// 1ms   4 150
//rom const int  draw_scale[]={180, 76};	// 2ms   6 180

//----- defines ------------------------------------------
#define ENDOFSCREEN 122u
#define STARTOFSCREEN 0u

//----- functions ----------------------------------------

// drawtype: 0=draw all  1=draw zeroline+curve  2=draw curve
void	draw_curve(char drawtype) {
	unsigned char i;
	unsigned char sx, d, s;
	unsigned char ds, st;
	unsigned int y0, y1, a;
	
	unsigned char z;
	unsigned char m,ap;
	unsigned char zx[10];
	unsigned char zy[10];
	
	dword tmpl;

	ap=0;
	ds=255;	// min
	st=0;		// max
	
	data2[255]=sampl_null;
	
	i=0;
	while(1) {
		s=shared1.predata[i];
		if(s>st)	st=s;
		if(s<ds)	ds=s;
		s=data[i];
		if(s>st)	st=s;
		if(s<ds)	ds=s;
		s=data2[i];
		if(s>st)	st=s;
		if(s<ds)	ds=s;
		
		i++;
		if(i==0u) break;
	}
	
	s=st-ds;
	d=3;
	if(s<55u) 		d=0;
	else if(s<111u)d=1;
	else if(s<223u)d=2;
//	if(draw_ud==255u) draw_ud=d;
	//if(draw_ud>d) draw_ud=0;
	if(draw_ud>d) draw_ud=d;
	
//	y0=draw_u0+64-(predata[prepek+i]>>draw_ud);
//	draw_ud&=3;
	
	ds>>=draw_ud;	
	st>>=draw_ud;	
	
	if(draw_u0>200u) draw_u0=200u;	
//	if(draw_u0<ds) draw_u0=ds;
	if((draw_u0+55u)>st) draw_u0=st-55;
	if(st<55u) draw_u0=0;
	if(draw_u0<ds) draw_u0=ds;
	
	// t0: 0-640 (td=0),  0-512 (td=1),  0-256 (td=2),  0 (td=3)
	glcd_open();
	draw_td&=3;

	z=sampl_null>>draw_ud;
	y1=draw_u0+63u-z ;

	if(drawtype==0u) {
		tmpl.longu=draw_u0;
		glcd_xy(78,0);
		if	(y1<36u) {
			glcd_puts_rom( "" ); // dn
		}
		else {		
			tmpl.longu+=(56u<<draw_ud);
			glcd_puts_rom( "" ); // up
		}
		
		tmpl.longs-=sampl_null;
		tmpl.longs*=sampl_amp_mul[sampl_amplifier]; 
		tmpl.longs*=EEPROM_get_int(4); // ~4000 ~2^12
		if(sampl_amp_ch[sampl_amplifier]==1u) {
			tmpl.longs*=10;
			tmpl.longs/=64;			
		}
		
		i2str(tmp_str, tmpl.hs, I2STR_2DEC);
		glcd_puts( tmp_str );
		glcd_puts_rom( "v" );
	}
	
//	glcd_PlotMode(GLCD_B_W);	
	glcd_PlotMode(GLCD_SET);
	
	if(drawtype!=2u) {
		for(i=0; i<128u; i+=3)
			glcd_plot( i, y1 );
		
		for(i=ENDOFSCREEN; i<126u; i++) {
			glcd_plot( i+2, y1-1 );
			glcd_plot( i+2, y1+1 );
		}
	}
	
	ds=sampl_step[sampl_mode][draw_td];
	if(draw_t0>250u) draw_t0=0;
	
	switch(draw_td) {
		case 0:	
			d=1;	//	ds=30;
			if(draw_t0>80u) draw_t0=80;
			break;
		case 1:	
			if(draw_t0>64u) draw_t0=64;
			d=2;	//	ds=75;
			break;		
		case 2:	
			if(draw_t0>32u) draw_t0=32;
			d=4;	//	ds=150;
			break;		
		case 3:
			draw_t0=0;	
			d=6;	//	ds=150;
	}
	

	sx=STARTOFSCREEN;	// sx=0; ScreenX
	s=d;
	i=draw_t0<<3;
	z=0;
	
	st=~i;
	while(st>ds){
		st-=ds;	
	}
	m=st;

	y0=draw_u0+63-(shared1.predata[prepek+i]>>draw_ud);
	
	if(draw_t0<32u) {	
		while(1){
			
//			glcd_plot( sx, draw_u0+64-(predata[prepek+i]>>draw_ud) );

			y1=draw_u0+63-(shared1.predata[prepek+i]>>draw_ud) ;
			glcd_plot( sx, y1);
			if((y0&0xfe)!=(y1&0xfe))
				glcd_plot( sx, (unsigned int)(y0+y1)>>1 );
				
			if((y0&0xf8)!=(y1&0xf8)) {
				glcd_plot( sx, (unsigned int)(y0+y0+y0+y1)>>2 );
				glcd_plot( sx, (unsigned int)(y0+y1+y1+y1)>>2 );
			}
			y0=y1;
			
			i++;
			s--;
			if(s==0u) {
				sx++;
				s=d;
				if(sx==ENDOFSCREEN) goto drawend;
			}

			if(st==0u && drawtype==0u) {
				if(ap==0u) { 
					a=i-1;
					ap++;
				}
				glcd_pix_col(sx, 1 ,7, 0b01010010);
				st=ds;
				zx[z]=sx;
				zy[z]=y0;
				z++;				
			}
			st--;
			
			if(i==0u) {
				if(drawtype<2u) glcd_pix_col(sx, 1 ,7, 0b01111110);
				break;			
			}
		}
		
		//glcd_print_xy_rom_v(draw_vline, sx, 0 );
		if(ap==0u) { 
			a=256;
			ap++;
		}
//		glcd_pix_col(sx, 1 ,7, 0b01111110);
	}	
	else {
		y0=draw_u0+64-(data[i]>>draw_ud);	
	}

	st=i;
	while(st>=ds){
		st-=ds;	
	}
	st=ds-st;
	
	if(draw_t0<64u) {		
		while(1){
//			glcd_plot( sx, draw_u0+64-(data[i]>>draw_ud) );
			y1=draw_u0+63-(data[i]>>draw_ud);
			glcd_plot( sx, y1);
			
			if((y0&0xfe)!=(y1&0xfe))
				glcd_plot( sx, (unsigned int)(y0+y1)>>1 );	
						
			if((y0&0xf8)!=(y1&0xf8)) {
				glcd_plot( sx, (unsigned int)(y0+y0+y0+y1)>>2 );
				glcd_plot( sx, (unsigned int)(y0+y1+y1+y1)>>2 );
			}
			
			y0=y1;

			i++;
			s--;
			if(s==0u) {
				sx++;
				s=d;
				if(sx==ENDOFSCREEN) goto drawend;
			}

			st--;
			if(st==0u && drawtype==0u) {
				if(ap==0u) { 
					a=i+255;
					ap++;
				}
				glcd_pix_col(sx, 1 ,7, 0b01010010);
				st=ds;				
				zx[z]=sx;
				zy[z]=y0;
				z++;				
			}

			if(i==0u) break;			
		}
	}	
	else {
		y0=draw_u0+63-(data2[i]>>draw_ud);	
	}
		
	if(draw_t0<=80u) {		
		while(1){
//			glcd_plot( sx, draw_u0+64-(data2[i]>>draw_ud) );
			y1=draw_u0+64-(data2[i]>>draw_ud);
			glcd_plot( sx, y1);
			
			if((y0&0xfe)!=(y1&0xfe))
				glcd_plot( sx, (unsigned int)(y0+y1)>>1 );
				
			if((y0&0xf8)!=(y1&0xf8)) {
				glcd_plot( sx, (unsigned int)(y0+y0+y0+y1)>>2 );
				glcd_plot( sx, (unsigned int)(y0+y1+y1+y1)>>2 );
			}
			
			y0=y1;

			i++;
			s--;
			if(s==0u) {
				sx++;
				s=d;
				if(sx==ENDOFSCREEN) goto drawend;
			}

			st--;
			if(st==0u && drawtype==0u) {
				if(ap==0u) { 
					a=i+511;
					ap++;
				}
				glcd_pix_col(sx, 1 ,7, 0b01010010);
				st=ds;				
				zx[z]=sx;
				zy[z]=y0;
				z++;				
			}

			if(i==0u) break;			
		}
	}	

drawend:

	if(drawtype!=0u) return;
	
	s=sampl_cnt_div[sampl_mode][draw_td];
	y0=draw_t0;
	y0<<=3;	
	st=0;
	
	if(draw_t0<32u) {
		y0=y0+m;
		st=s;
		while(y0<256u){
			y0+=ds;	
			st-=s;
		}
	}
	else {	
		while(y0>=256u){
			y0-=ds;	
			st+=s;
		}
	}
	
	for(i=0; i<z; i++){
		if(zy[i]>36u)	glcd_xy(zx[i]+1,1);		
		else				glcd_xy(zx[i]+1,7);
//			itoa((signed char)st,tal); 
		i2str(tmp_str, (signed char)st, I2STR_NODOT);
		
		if( zx[i]<116u) glcd_puts( tmp_str );
		st+=s;		
	}

	glcd_close();
	
}
//--------------------------------------------------------
