// keyb.c

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

#include "main.h"
#include "andi.h"
#include "keyb.h"
#include "glcd.h"

//----- variables ----------------------------------------
unsigned char keyb_last_key;

//----- functions ----------------------------------------
void 	Keyb_init(void) {	
	keyb_last_key=255;
}
//--------------------------------------------------------

unsigned char	Keyb_get(void) {
	unsigned char tmp;

	keyb_last_key=255;
	tmp=Andi_high(0)>>1; // tmp=0-127
	if(tmp<KEYB_IN_START) {
		if(KEYB_ESC)	keyb_last_key=0;
	}
	else if(tmp<KEYB_IN_END_1)	keyb_last_key=1;
	else if(tmp<KEYB_IN_END_2) keyb_last_key=2;
	else if(tmp<KEYB_IN_END_3) keyb_last_key=3;
	else if(tmp<KEYB_IN_END_4) keyb_last_key=4;
	else if(tmp<KEYB_IN_END_5) keyb_last_key=5;
	else if(tmp<KEYB_IN_END_6) keyb_last_key=6;
	else if(tmp<=KEYB_IN_END_7) keyb_last_key=7;
	
	return keyb_last_key;
}
//--------------------------------------------------------

unsigned char	Keyb_wait_n_get(void) {
	unsigned char tmp;
	unsigned int i;

	tmp=200u;
	Keyb_get();
	while( (keyb_last_key&tmp) != 255u) {
		Delay10KTCYx(KEYB_DELAY);		
		tmp=keyb_last_key;
		Keyb_get();
	} 
	while( keyb_last_key!=tmp || tmp==255u )  {
		tmp=keyb_last_key;
		Keyb_get();
	} 

	return tmp;
}
