// main.c

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

//--------------------------------------------------------
#include "main.h"
#include <stdlib.h>
//#include <string.h>

#pragma config WDT = OFF
#pragma config OSC = HSPLL
#pragma config PWRT = ON
#pragma config BOREN = SBORDIS
#pragma config MCLRE = ON
#pragma config PBADEN = OFF
#pragma config LVP = OFF

//--------------------------------------------------------
//#include "main.h"
#include "spi_mc.h"
#include "glcd.h"
#include "andi.h"
#include "keyb.h"
#include "sci.h"
#include "mcp6sx.h"
#include "sampl.h"
#include "draw.h"
#include "menu.h"
#include "menus.h"
#include "i2str.h"
#include "EEPROMspi.h"                                    

//--------------------------------------------------------

// \n=10 

//---- ROM variables and tables --------------------------
rom const char string[]="Hello world";
rom const char string2[]="";
rom const char string3[]="Baron3D\n";

rom const char image[]={10,1
	,0b00011000 	,0b00100100 	,0b01001010 	,0b10000001 
	,0b01000010 	,0b00100100 	,0b00011000 	,0b00011000 
	,0b00100100 	,0b01000010 
};

rom const char image2[]={10,1
	,0b00011000 	,0b00100100 	,0b01001010 	,0b01000001 
	,0b01000010 	,0b00100100 	,0b00011000 	,0b00011000 
	,0b00101000 	,0b11000100 
};

rom const char image3[]={10,1
	,0b00011000 	,0b00100100 	,0b01001010 	,0b10000010 
	,0b01000010 	,0b00100100 	,0b00011000 	,0b00011000 
	,0b00010100 	,0b00100011 
};

rom const char clk[8][9]= {
	{	7,1					,0b00000000 		,0b00000000 
		,0b00000000 		,0b00001000 		,0b00000100 
		,0b00000010 		,0b00000100 
	}
//rom const char clk1[]=
	,{	7,1				,0b00000000 	,0b00000000 
		,0b00000000 	,0b00001111 	,0b00000001 
		,0b00000000 	,0b00000000 
	 }
	,{7,1
		,0b00000000 		,0b00000010 		,0b00000101 
		,0b00001000 		,0b00000000 		,0b00000000 
		,0b00000000 
	 }
	,{7,1
		,0b00001100 		,0b00001000 		,0b00001000 
		,0b00001000 		,0b00000000 		,0b00000000 
		,0b00000000 
	 }
	,{7,1
		,0b00010000 		,0b00100000 		,0b00010000 
		,0b00001000 		,0b00000000 		,0b00000000 
		,0b00000000 
	 }
	,{7,1
		,0b00000000 		,0b00000000 		,0b01000000 
		,0b01111000 		,0b00000000 		,0b00000000 
		,0b00000000 
	 }
	,{7,1
		,0b00000000 		,0b00000000 		,0b00000000 
		,0b00001000 		,0b01010000 		,0b00100000 
		,0b00000000 
	 }
	,{7,1
		,0b00000000 		,0b00000000 		,0b00000000 
		,0b00001000 		,0b00001000 		,0b00001000 
		,0b00011000 
	}
};


//rom const char strtst[]={32,32, 14, 83, 0, 0, 0};

//rom const char menupos1[]={0,5,10,15};
//rom const char menustr1[]="Menu <--> |<>| \//\ ";
//rom const char menucmd1[]="11110222203333044440";
//                         123456789012345678901

//--------------------------------------------------------

unsigned char clkcnt;
// ----- external variables ------------------
char tmp_str[25];

#pragma udata data_section1=0x200
sh1 shared1;
	
#pragma udata data_section2=0x300
unsigned char data[256];
#pragma udata data_section3=0x400
unsigned char data2[256];
#pragma udata
char unsigned prepek;
char unsigned datapek;


//--------------------------------------------------------

void tst(void){
	unsigned int i;	
	clkcnt++;
	clkcnt&=7;
	Delay10KTCYx(80u);
	glcd_draw_xy_rom( clk[clkcnt], 80, 5);
}
//--------------------------------------------------------

void main (void)
{
	unsigned int i, i2;
	unsigned int k;
	unsigned char in,in2;
	eedata_Write wr_desc;	

	clkcnt=0;

	Delay10KTCYx(80u);		

	spi_init();
	eepspi_init();
	glcd_init();
	Andi_init();
	Keyb_init();
	Sci_init();
	mcp6sx_init();
	
//------------------	

	mcp6sx_set(0,2);  // (ch , f)
//	for(i=0; i<60000u; i++) ;		

	i=Andi_high(ADC_CH1);	
	
	while( ANDI_BUSY );
	ANDI_GO	// start conversion
	while( ANDI_BUSY );
	while( ANDI_BUSY );
	while( ANDI_BUSY );
	i=ADRESH;	

//	itoa(i,tmp_str); 
	i2str(tmp_str, i, I2STR_NODOT);
	Sci_puts_rom("U=");
	Sci_puts(tmp_str);
	Sci_puts_rom("V");

	mcp6sx_set(0,0);  // (ch , f)

	glcd_clear_openclose();
	
	sampl_mode=0;
	sampl_null=Andi_high(ADC_CH2);
	sampl_trglev=sampl_null;
	sampl_trgmode=1;
	sampl_amplifier=0;
	

	if(!KEYB_ESC )
		Menus_main();
	
	glcd_clear_openclose();
	
	
	eepspi_open( 0, 0, EEPspiA16);	
	eepspi_gets( tmp_str, 25);
	eepspi_close();
//	tmp_str[7]=0;
	Sci_puts_rom("\n");
	Sci_puts(tmp_str);
	
	Sci_puts_rom_wait("hej\n");
	
	for(i=0; i<24u; i++){
		if(tmp_str[i]==0u)	{
			tmp_str[i]=tmp_str[i-1]+1;
			tmp_str[i+1]=0;
			break;
		}
	}
		
	wr_desc.page=8;
	eepspi_open( &wr_desc, 0, EEPspiA16);
	if(KEYB_ESC )
		i2str(tmp_str, 123, I2STR_NODOT);
	eepspi_puts ( tmp_str );	
	Sci_puts_rom_wait("pgr.....\n");
	eepspi_close();

//	Sci_puts_rom_wait("hej\n");
//	Sci_puts_rom(strtst);
	Sci_puts_rom(string3);

	mcp6sx_set(0,0);

	glcd_open();

	i=Andi_int(ADC_CH0);
//	i>>=1;
//	itoa(i,tmp_str); 
	i2str(tmp_str, i-300, I2STR_2DEC);
	glcd_print_xy( tmp_str, 0, 0 );

	glcd_print_xy_rom( string, 6, 2);
	glcd_print_xy_rom( string2, 70, 3);
	glcd_draw_xy_rom( image, 60, 4);

//		Sci_puts_rom_wait(string3);


  	while (1) {
		tst();
		glcd_draw_xy_rom( image2, 60, 4);
		tst();
		glcd_draw_xy_rom( image,  60, 4);
		tst();
		glcd_draw_xy_rom( image3, 60, 4);
		tst();
		glcd_draw_xy_rom( image,  60, 4);
	}
	glcd_close();

}
//--------------------------------------------------------

/*
 {

}
//--------------------------------------------------------
*/


