// menu.h

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

#include "main.h"
#include "menu.h"
#include "keyb.h"
#include "sampl.h"
#include "menus.h"


//----- functions ----------------------------------------------	

unsigned int  menu_render(MENU_TABLE me, unsigned char defpos) {
	unsigned char i, x, y, h;
	
	while(1) {
		x = me->info.x*6;
		y = me->info.y;
		h = me->info.num&31;
		
		if(defpos>128u)					defpos=h-1;
		if(defpos>=h)	defpos=0;
		
		glcd_open();
		
		if(me->info.num&MENU_HORIZONTAL) {
			// MENU_HORIZONTAL
			glcd_xy(x, y);
			for(i=0; i<h; i++){
				if(i==defpos){
					glcd_TextMode(GLCD_W_B);	
					glcd_puts_rom(me->data[i].txt);	
					glcd_TextMode(GLCD_B_W);
				}
				else {
					glcd_puts_rom(me->data[i].txt);
				}
				glcd_write(0);
			}
		}
		else {
			// MENU_VERITCAL
			glcd_clear(x, y ,me->info.w*6, me->info.h);
			if(me->info.num&MENU_BORDER) {
				glcd_xy(x, y);
				glcd_print_char(147);
				glcd_fill_row(x+6, y, me->info.w-2, 145);
				glcd_print_char(148);
				
				i=y + 1;
				h=me->info.h-2+i;
				for(; i<h; i++){
					glcd_xy(x, i);
					glcd_print_char(146);
					glcd_xy(x+ (me->info.w-1)*6, i);
					glcd_print_char(146);					
				}
				
				glcd_xy(x, i);
				glcd_print_char(149);
				glcd_fill_row(x+6, i, me->info.w-2, 145);				
				glcd_print_char(150);
				
				x+=6;
				y++;
			}
			
			h=me->info.num&31;

			if(me->info.num&MENU_CAPTION) {
				y = me->info.y;				
				glcd_print_xy_rom(me->data[h].txt, x, y);
				y++;
			}

			for(i=0; i<h; i++){
				glcd_xy(x, y);
				y++;
				if(i==defpos){
					glcd_TextMode(GLCD_W_B);	
					glcd_puts_rom(me->data[i].txt);	
					glcd_TextMode(GLCD_B_W);
				}
				else {
					glcd_puts_rom(me->data[i].txt);
				}
			}
		}
		
		if(me->info.render) me->info.render();
		
		glcd_close();
		i=Keyb_wait_n_get();
		if(i==0u) return defpos ;
		if(i==1u) defpos--;
		if(i==2u) defpos++;
		if(i==3u) return defpos | 0x300;
		if(i==4u) return defpos | 0x400;
		if(i==7u) return defpos | 0x700;	
	}
}
//--------------------------------------------------------
