// menu.h

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

#ifndef menu_h
#define menu_h
#include "main.h"
#include "glcd.h"

//----- defines ------------------------------------------
#define MENU_HORIZONTAL 128
#define MENU_VERITCAL	0
#define MENU_BORDER 		64
#define MENU_VERITCAL	0
#define MENU_CAPTION		32
#define MENU_CAST			(Mmenu2*)
#define MENU_TABLE		Mmenu2*
#define MENU_NoESC_MENU	0
#define MENU_NoRENDER	0

#define MENU_FN			1
#define MENU_MENU			2

	
//----- declars ------------------------------------------
 typedef rom struct {
	union { 
		rom void (*func)(void);
		rom void* pek;
	} p;
	rom unsigned char p_type;
	rom unsigned char *txt;
} Mitem;

typedef rom struct {
	rom unsigned char num;
	rom unsigned char x;
	rom unsigned char y;
	rom unsigned char w;
	rom unsigned char h;
	rom void *esc_menu;
	rom char (*render)(void);
} Mbas;

typedef rom struct {
	rom Mbas  info;
	rom Mitem data[2];	
} Mmenu2;

typedef rom struct {
	rom Mbas  info;
	rom Mitem data[3];	
} Mmenu3;

typedef rom struct {
	rom Mbas  info;
	rom Mitem data[4];	
} Mmenu4;

typedef rom struct {
	rom Mbas  info;
	rom Mitem data[5];	
} Mmenu5;

typedef rom struct {
	rom Mbas  info;
	rom Mitem data[6];	
} Mmenu6;

typedef rom struct {
	rom Mbas  info;
	rom Mitem data[7];	
} Mmenu7;

typedef rom struct {
	rom Mbas  info;
	rom Mitem data[8];	
} Mmenu8;



//----- functions ----------------------------------------
// ret val = low byte-menu pos    high byte-button 
unsigned int menu_render(MENU_TABLE me, unsigned char defpos);


//--------------------------------------------------------
#endif
	
