// menus.c

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

#include <stdlib.h>

#include "main.h"
#include "spi_mc.h"
#include "glcd.h"
#include "andi.h"
#include "keyb.h"
#include "sci.h"
#include "mcp6sx.h"
#include "sampl.h"
#include "draw.h"
#include "menu.h"
#include "menus.h"
#include "i2str.h"
#include "volt.h"
#include "EEPROMspi.h"                                    
#include "eeprom.h"


void Messure(void) ;
unsigned int  menus_k;
unsigned char menus_in;	
unsigned char menus_tmp;	
unsigned char menus_tmp2;	
unsigned char menus_tmp3;	
	
unsigned char  Mesurepoint1;
unsigned char  Mesurepoint2;
word  menus_word;

unsigned char file_eeprom;

union {
	eedata_Write wr_desc;	
	dword tmpl;
}t_data;


//----- data ---------------------------------------------

rom char mm_scope[]="Digital Scope";
rom char mm_voltm[]="Voltage meter";
rom char mm_games[]="Games";

char funk1(char);
rom char me_ampl[] ="Ampl :";
rom char me_time[] ="Time :";
rom char me_trig[] ="Trig :";
rom char me_level[]="Level:";
rom char me_files[]="Files";
rom char me_go[]   ="GO";
rom char me_scope[]="Digital Scope";
// code 145 = vertical "="  = ""
// code 146 = "=" = ""

/*
rom char m_lr[]={142, 144, 0}; // <->   l+r arrow
rom char m_lp[]={143, 160, 0}; // ->|   minus+arrow_pipe
rom char m_du[]={136,  32, 0}; // dn_up arrow
rom char m_uu[]={158,  32, 0}; // up arrow_to_limit
rom char m_pf[]={'+', '?', 0}; // 
*/
rom char m_lr[]={142, 144, 0}; // <->   l+r arrow
rom char m_lp[]={160,   0, 0}; // ->|   minus+arrow_pipe
rom char m_du[]={136,   0, 0}; // dn_up arrow   
rom char m_uu[]={158,   0, 0}; // up arrow_to_limit
rom char m_pf[]={'?',   0, 0}; // 
	
rom Mmenu4 menusubtst;

// menutype       numitems + options , x, y, w , h, render_fn , 
rom Mmenu6 menumain={5 | MENU_VERITCAL | MENU_BORDER | MENU_CAPTION, 1,1,19,7,
			MENU_NoESC_MENU,
			MENU_NoRENDER, 
			Menus_scope, MENU_FN, mm_scope,
			Volt_meter, MENU_FN, mm_voltm,
			(rom void* )&menusubtst, MENU_MENU, mm_games,
			0,0, " ",
			Menus_calib, MENU_FN, "Calibration",			
			0,0, " Main menu " // CAPTION
};
	
char menu1render(void);	

// menutype       numitems + options , x, y, w , h, render_fn , 
rom Mmenu7 menuscope={6 | MENU_VERITCAL | MENU_BORDER | MENU_CAPTION, 1,0,19,8,
			MENU_NoESC_MENU,
			Menus_scope_render, 
			0,0, me_ampl,
			0,0, me_time,
			0,0, me_trig,
			0,0, me_level,
			0,0, me_files,
			0,0, me_go,			
			0,0, me_scope // CAPTION
};

// menutype       numitems + options , x, y, w , h, render_fn , 
rom Mmenu5 menucurve={5 | MENU_HORIZONTAL, 0, 0, 10, 6,          
			MENU_NoESC_MENU,
			MENU_NoRENDER,
			0,0, m_lr,
			0,0, m_lp,
			0,0, m_du,
			0,0, m_uu,
			Messure, MENU_FN, m_pf,
};

// menutype       numitems + options , x, y, w , h, render_fn , 
rom Mmenu4 menusubtst={3 | MENU_VERITCAL | MENU_BORDER  | MENU_CAPTION, 2, 1, 17, 5,
			&menumain,
			MENU_NoRENDER,
			0,0, "kjshdk",
			0,0, "dfdf",
			0,0, "lj8765g",
			0,0, mm_voltm,
};

// menutype       numitems + options , x, y, w , h, render_fn , 
rom Mmenu5 menus_files={4 | MENU_VERITCAL | MENU_BORDER | MENU_CAPTION, 3,1,15,6,
			MENU_NoESC_MENU,
			Menus_files_render, 
			0,0, "Abort",
			0,0, "Save",
			0,0, "Load",
			0,0, "File:",
			0,0, "Files" // CAPTION
};

// menutype       numitems + options , x, y, w , h, render_fn , 
rom Mmenu3 menus_calib={2 | MENU_VERITCAL | MENU_BORDER | MENU_CAPTION, 1,1,19,4,
			MENU_NoESC_MENU,
			MENU_NoRENDER, 
			0,0, "5V  -> In1 & In3",
			0,0, "1V^ -> In2",
			0,0, "Calibration" // CAPTION
};

//----- functions ----------------------------------------
void Menus_main(void) {
	Mmenu2 *m;
	
	file_eeprom=0;	

	m=MENU_CAST&menumain;
	menus_in=255;
	menus_k=0;
	glcd_clear_openclose();

	while(1) {
		menus_k=menu_render(m,0);		
		menus_in=menus_k>>8;		
		
		if(menus_in==0u) {
			if(m->info.esc_menu) {
				m=m->info.esc_menu;				
			}
		}
		
		if(menus_in==7u) {	
			switch(m->data[menus_k&255].p_type) {
				case MENU_FN:
					m->data[(menus_k&255)].p.func();
					break;
				case MENU_MENU:	
					m=m->data[(menus_k&255)].p.pek;
					break;
			}	
			glcd_clear_openclose();
		}	
	}	
}
//-----------------------------------------------------------------------

void Menus_scope(void) {
	menus_in=255;
	menus_k=0;
	while(menus_in != 0u) {
		sampl_null=Andi_high(ADC_CH2);	

		/*
		if(menus_in==7u){
			draw_td=3;
			Menus_curve();
			menus_in=255;
			menus_k=0;
		}
		*/
		
		switch(menus_k&255)	{
			case 0:// voltage
				if(menus_in==3u) sampl_amplifier--;
				if(menus_in==4u) sampl_amplifier++;
				break;
			case 1: //timing
				if(menus_in==3u) sampl_mode--;
				if(menus_in==4u) sampl_mode++;
				break;
			case 2:// trig mode
				if(menus_in==3u) sampl_trgmode--;
				if(menus_in==4u) sampl_trgmode++;
				break;
			case 3:// trig level
				if(menus_in==3u) sampl_trglev-=4;
				if(menus_in==4u) sampl_trglev+=4;
				break;
			case 4:// trig level
				if(menus_in!=7u) break;
				Menus_files(SCOPE_CURVE);
				if((menus_k&255)==2u) {
					draw_td=3;
					Menus_curve(1);
					menus_in=255;
					menus_k=0;					
				}				
				break;
			case 5:// trig level
				if(menus_in!=7u) break;
				draw_td=3;
				Menus_curve(0);
				menus_in=255;
				menus_k=0;
				break;
		}
		if(sampl_mode>127u)              sampl_mode=SAMPLE_NUM_MODES-1;
		if(sampl_mode>=SAMPLE_NUM_MODES) sampl_mode=0;

		if(sampl_trgmode>127u) 					sampl_trgmode=SAMPLE_NUM_TRIG-1;
		if(sampl_trgmode>=SAMPLE_NUM_TRIG) 	sampl_trgmode=0;
		
		if(sampl_amplifier>127u) 				sampl_amplifier=SAMPLE_NUM_AMP-1;
		if(sampl_amplifier>=SAMPLE_NUM_AMP) sampl_amplifier=0;		
		
		glcd_clear_openclose();

		menus_k=menu_render(&menuscope,menus_k&255);		
		menus_in=menus_k>>8;
	}	
}
//-----------------------------------------------------------------------

char Menus_scope_render(void) {
		glcd_print_xy_rom( sampl_amp_str[sampl_amplifier], 52, 1);
		glcd_print_xy_rom( sampl_time_str[sampl_mode], 52, 2);
		glcd_print_xy_rom( sampl_trig_str[sampl_trgmode], 52, 3);

		i2str(tmp_str, sampl_trglev, I2STR_NODOT);
		glcd_print_xy( tmp_str, 52, 4);
		glcd_puts_rom(" (");
 		i2str(tmp_str, sampl_null, I2STR_NODOT);
		glcd_puts( tmp_str );
		glcd_puts_rom("=0V)");
}
//-----------------------------------------------------------------------

void Menus_curve(char show) {

	glcd_clip(0, 1, 128, 7);

	draw_t0=0;
	draw_td=3;
	draw_u0=0;
	draw_show=0;
	Mesurepoint1=32;								
	Mesurepoint2=96;								
	
	while(1){
//		sampl_mode=0;
//		sampl_triglevel=1;
		glcd_clear_openclose();		
		draw_ud=255;		
		
//		mcp6sx_set(0,0);  // (ch , f)
		mcp6sx_set(sampl_amp_ch[sampl_amplifier], sampl_amp[sampl_amplifier]);// ch, f
		if(show==0u) sampl(); 
		show=0;
		
		menus_in=255;
		menus_k=0;
		while(menus_in != 7u) {
			
			// in = button   255=no_button  0=esc  3,4  7=OK
			if(menus_in==0u){
				return;			
			}
			// (k&255) = menu choice
			switch(menus_k&255)	{
				case 0:
					if(menus_in==3u) draw_t0-=4;
					if(menus_in==4u) draw_t0+=4;
					break;
				case 1:
					if(menus_in==3u) draw_td++;
					if(menus_in==4u) draw_td--;
					break;
				case 2:
					if(menus_in==3u) {
						if(draw_u0<8u) draw_u0=8;
						draw_u0-=8;
					}
					if(menus_in==4u) {
						if(draw_u0>247u) draw_u0=247;						
						draw_u0+=8;
					}
					break;
				case 3:
					if(menus_in==3u) draw_ud++;
					if(menus_in==4u) draw_ud--;
					break;
				case 4:
					if(menus_in==3u) Messure();
					if(menus_in==4u) Messure();
					break;
			}
			
			glcd_clear_openclose();
			
			draw_curve(0);

			glcd_open();
			glcd_TextMode(GLCD_W_B);	
			glcd_print_xy_rom(sampl_str[sampl_div[sampl_mode][draw_td]] , 42, 0);
			glcd_print_char('s');
			glcd_TextMode(GLCD_B_W);	
		/*	
			glcd_print_xy_rom( sampl_amp_div[draw_ud+(sampl_amplifier<<2)], 102, 0);
			glcd_print_char('V');
		*/
			glcd_close();
			
			menus_k=menu_render(&menucurve,menus_k&255);		
			menus_in=menus_k>>8;
		}
	
	}

}
//-----------------------------------------------------------------------

char Menus_files_render(void) {
		i2str(tmp_str, file_eeprom, I2STR_NODOT);
		glcd_print_xy( tmp_str, 62, 5);
}
//-----------------------------------------------------------------------

void Menus_files(unsigned char f) {
	// SCOPE_CURVE
	
	menus_in=255;
	menus_k=0;
	while(menus_in != 0u) {
		glcd_clear_openclose();
		
		switch(menus_k&255)	{
			case 0:// abort
				if(menus_in==7u) return;
			case 1:// save
				if(menus_in!=7u) break;
				t_data.wr_desc.page=64;
				eepspi_open( &t_data.wr_desc, (((long)file_eeprom)<<10)+24576, EEPspiA16);
				eepspi_put( prepek );
				eepspi_put( sampl_amplifier );
				eepspi_put( sampl_mode );
				eepspi_write( shared1.predata, 768);	
				eepspi_close();				
				return;
			case 2: //load				
				if(menus_in!=7u) break;
				eepspi_open( 0, (((long)file_eeprom)<<10)+24576, EEPspiA16);	
				prepek = eepspi_get();
				sampl_amplifier = eepspi_get();
				sampl_mode = eepspi_get();
				eepspi_read( shared1.predata, 768);	
				eepspi_close();				
				return;
			case 3:// file number 0 - 3
				if(menus_in==3u) file_eeprom--;
				if(menus_in==4u) file_eeprom++;
				break;
		}
		
		if(file_eeprom>127u) file_eeprom=8-1;
		if(file_eeprom>=8u)  file_eeprom=0;		
		
		menus_k=menu_render(&menus_files, menus_k&255);		
		menus_in=menus_k>>8;
	}	
}
//-----------------------------------------------------------------------

void samp_get_data(unsigned char pos) {	
	menus_word.iu=(pos*menus_tmp,PROD) + ((unsigned int)draw_t0<<3);
		
	if(menus_word.hu==0u) {
		menus_tmp3=shared1.predata[prepek+menus_word.lu];			
	}
	if(menus_word.hu==1u) {
		menus_tmp3=data[menus_word.lu];
	}
	if(menus_word.hu==2u) {
		menus_tmp3=data2[menus_word.lu];
	}	


	t_data.tmpl.longu=menus_tmp3;
	t_data.tmpl.longs-=sampl_null;
	t_data.tmpl.longs*=sampl_amp_mul[sampl_amplifier]; // <<0, <<1, <<2
	t_data.tmpl.longs*=EEPROM_get_int(4); // ~4000 ~2^12
/*
	menus_word.is=menus_tmp3;
	//menus_word.is-=sampl_amp_L0[sampl_amplifier];
	menus_word.is-=sampl_null;	
	menus_word.is*=sampl_amp_mul[sampl_amplifier];
	//calib_ch2=EEPROM_get_int(4);
	
	menus_tmp3=menus_word.hu;
	menus_word.is>>=4;
	if(menus_tmp3&128) menus_word.hu|=240;
	
//	menus_word.is/=16;  // +31 bytes
//	menus_word.is/=(unsigned int)16;  // -11 bytes
*/
	i2str(tmp_str, t_data.tmpl.hs, I2STR_2DEC);
}
//-----------------------------------------------------------------------

void Messure(void) {
	menus_tmp2=0;
	menus_k=255;

	menus_tmp=1;
	if(draw_td) menus_tmp=draw_td<<1;
			
	while(1) {			
			if((menus_k&255)==7u)	menus_tmp2^=1;
			
			menus_tmp3=Mesurepoint1;
			if(menus_tmp2)	menus_tmp3=Mesurepoint2;
			
			switch(menus_k&255)	{
				case 0:	//esc
					return;
				case 1: 
					menus_tmp3-=8;
					break;
				case 2:
					menus_tmp3+=8;
					break;
				case 3:
					menus_tmp3-=1;
					break;
				case 4:
					menus_tmp3+=1;
			}
			
			if(menus_tmp3>246u) {
				menus_tmp3=3;
				draw_t0-=menus_tmp;
			}

			if(menus_tmp3>127u) {
				menus_tmp3=124;
				draw_t0+=menus_tmp;
			}			

			if(menus_tmp2)	{
				Mesurepoint2=menus_tmp3;
				if(Mesurepoint1>Mesurepoint2) Mesurepoint1=Mesurepoint2;
			}
			else	{      
				Mesurepoint1=menus_tmp3;			
				if(Mesurepoint1>Mesurepoint2) Mesurepoint2=Mesurepoint1;
			}
	
			glcd_clear_openclose();
			draw_curve(2);

			glcd_open();
			if(menus_tmp2) {
//				glcd_print_xy_rom("P2" , 0, 0);
				glcd_pix_col(Mesurepoint1, 1 ,7, 0b01010010);
				glcd_pix_col(Mesurepoint2, 1 ,7, 0b01111110);	
//				samp_get_data( Mesurepoint2 );
//				glcd_print_xy( tmp_str, 18, 0);

			}
			else  {
//				glcd_print_xy_rom("P1" , 0, 0);
				glcd_pix_col(Mesurepoint1, 1 ,7, 0b01111110);
				glcd_pix_col(Mesurepoint2, 1 ,7, 0b01001010);	
//				samp_get_data( Mesurepoint1);
//				glcd_print_xy( tmp_str, 18, 0);
			}

			samp_get_data( Mesurepoint1 );
			glcd_print_xy( tmp_str, 0, 0);
			glcd_print_char('V');
			samp_get_data( Mesurepoint2 );
			glcd_print_xy( tmp_str, 42, 0);
			glcd_print_char('V');
			
			menus_tmp3=Mesurepoint2-Mesurepoint1;
			u2str(tmp_str, 
				( (unsigned int)(menus_tmp3*menus_tmp,PROD) *
				(unsigned int)sampl_time_mul[sampl_mode] )>>sampl_time_shift[sampl_mode]
				, 5-sampl_time_dot[sampl_mode]);
			glcd_print_xy( tmp_str, 84, 0);
			
			if(sampl_mode<9u) {// time="ms" 
				glcd_print_char('m');
			} //		else { //"s"						
			glcd_print_char('s');

			glcd_close();
	
			menus_k=Keyb_wait_n_get();
	}
	glcd_clear_openclose();
}
//-----------------------------------------------------------------------

void Menus_calib(void){
	menus_in=255;
	menus_k=0;
	while(menus_in != 0u) {
		glcd_clear_openclose();
		
		switch(menus_k&255)	{
			case 0: // 5V=
				if(menus_in!=7u) break;
				shared1.al=Andi_int(ADC_CH2);
				shared1.al<<=5;
				shared1.al-=1;
				
				mcp6sx_set(0,1);  // (ch , f)	f=2
				Andi_int(ADC_CH1);
				volt_get_voltage(5);
				// 2*500*65536 / (ADin - ref0)
				shared1.dw.longs=65536000/(shared1.dw.longs-shared1.al); // 5.00V
			   EEPROM_put_int( 0, shared1.dw.ls );

				mcp6sx_set(2,1);  // (ch , f)	f=2
				Andi_int(ADC_CH1);
				volt_get_voltage(5);
				
				shared1.dw.longs=65536000/(shared1.dw.longs-shared1.al); // 5.00V
			   EEPROM_put_int( 4, shared1.dw.ls );

				break;
			case 1: // 1V~				
				if(menus_in!=7u) break;


				shared1.dw.longs=6553600/(shared1.cl-shared1.al); // 1.00V
			   EEPROM_put_int( 2, shared1.dw.ls );
				break;
		}
		
		menus_k=menu_render(&menus_calib, menus_k&255);		
		menus_in=menus_k>>8;
	}		
}
//-----------------------------------------------------------------------

