// sampl.h

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

#ifndef sampl_h
#define sampl_h
#include "andi.h"

//----- defines ------------------------------------------
#define SAMPLE_NUM_MODES 18u
#define SAMPLE_NUM_TRIG  7u
#define SAMPLE_NUM_AMP   7u

//----- functions ----------------------------------------
void sampl(void);

extern rom unsigned char sampl_div[SAMPLE_NUM_MODES][4];
extern rom unsigned char sampl_step[SAMPLE_NUM_MODES][4];
extern rom unsigned char sampl_str[9][6];
extern rom unsigned char sampl_time_str[SAMPLE_NUM_MODES][11];
extern rom unsigned char sampl_trig_str[SAMPLE_NUM_TRIG][10];
extern rom unsigned char sampl_cnt_div[SAMPLE_NUM_MODES][4];
extern rom unsigned char sampl_time_mul[SAMPLE_NUM_MODES];
extern rom unsigned char sampl_time_shift[SAMPLE_NUM_MODES];
extern rom unsigned char sampl_time_dot[SAMPLE_NUM_MODES];

extern rom unsigned char sampl_amp_str[SAMPLE_NUM_AMP][7];
extern rom unsigned char sampl_amp[SAMPLE_NUM_AMP];
extern rom unsigned char sampl_amp_ch[SAMPLE_NUM_AMP];
// extern rom unsigned char sampl_amp_L0[SAMPLE_NUM_AMP];
// extern rom unsigned char sampl_amp_step[SAMPLE_NUM_AMP*4];
// extern rom unsigned char sampl_amp_div[SAMPLE_NUM_AMP*4][6];
extern rom unsigned char sampl_amp_mul[SAMPLE_NUM_AMP];

extern unsigned char sampl_mode;
extern unsigned char sampl_trglev;
extern unsigned char sampl_trgmode;
extern unsigned char sampl_amplifier;
extern unsigned char sampl_null;
	
//--------------------------------------------------------
#endif
