// volt.c

// ***************************************************************
// *               Copyright (C) Frank Linder                    *
// * Permission is granted to use, modify, or redistribute this  *
// * software so long as it is not sold or exploited for profit. *
// *    Provided "as is" without express or implied warranty.    *
// ***************************************************************

#include <stdlib.h>

#include "main.h"
#include "sci.h"
#include "i2str.h"
#include "andi.h"
#include "mcp6sx.h"
#include "glcd.h"
#include "volt.h"
#include "keyb.h"
#include "bigfont.h"
#include "eeprom.h"

//--------------------------------------------------------
void Volt_meter(void) {

	Andi_setup(ADC_FOSC_64);
	
	glcd_clear_openclose();	

	glcd_open();
	glcd_print_xy_rom( "-- Voltage meter --", 7, 0 );
	glcd_close();
	
	shared1.trim0=EEPROM_get_int(0);
//	shared1.trim1=EEPROM_get_int(2);
	shared1.trim2=EEPROM_get_int(4);
	
	while(!KEYB_ESC) {
		
		
		shared1.al=Andi_int(ADC_CH2);
		shared1.al<<=5;
		shared1.al-=2;
		
		mcp6sx_set(2,0);  // (ch , f)	
		Andi_int(ADC_CH1);

		volt_get_voltage(20);				
		
//		shared1.dw.longs-=9407;
		shared1.dw.longs-=shared1.al;
		shared1.dw.longs*=shared1.trim2;

		glcd_open();
		i2str(tmp_str, shared1.dw.hs, I2STR_2DEC);
		
		//		glcd_print_xy( tmp_str, 64, 2 );
		bigfont_print_xy( tmp_str, 64, 2 );
		
//		glcd_print_char(' ');
		bigfont_print_space();
		//---
		shared1.dw.longs=shared1.max;
		shared1.dw.longs<<=5;
//		shared1.dw.longs-=9407;
		shared1.dw.longs-=shared1.al;
		shared1.dw.longs*=shared1.trim2;
				
		i2str(tmp_str, shared1.dw.hs, I2STR_2DEC);
		
		glcd_print_xy_rom( "Max=", 64, 4 );
		glcd_print_xy( tmp_str, 90, 4 );
		glcd_print_char(' ');
				
		//---
		shared1.dw.longs=shared1.min;
		shared1.dw.longs<<=5;
//		shared1.dw.longs-=9407;
		shared1.dw.longs-=shared1.al;
		shared1.dw.longs*=shared1.trim2;
				
		i2str(tmp_str, shared1.dw.hs, I2STR_2DEC);
		
		glcd_print_xy_rom( "Min=", 64, 5 );
		glcd_print_xy( tmp_str, 90, 5 );
		glcd_print_char(' ');
				
		glcd_close();

	//-------------		
		mcp6sx_set(0,0);  // (ch , f)	
		Andi_int(ADC_CH1); 
		volt_get_voltage(2);		
		
		shared1.dw.longs-=shared1.al;
		shared1.dw.longs*=shared1.trim0;
		
		glcd_open();
		i2str(tmp_str, shared1.dw.hs, I2STR_2DEC);
//		glcd_print_xy( tmp_str, 2, 2 );
		bigfont_print_xy( tmp_str, 2, 2 );
//		glcd_print_char(' ');
		bigfont_print_space();
		glcd_close();
	}	
}

//--------------------------------------------------------
void volt_get_voltage(unsigned char a) {	
//	32MHz/64=500k tad
// 1conv=31tad ->16,129k/s
//	16129/1600=~10;
	
//	shared1.au=0;
	shared1.max=0;
	shared1.min=1023;	
	shared1.dw.longu=0;
	
	for(shared1.cu=256; shared1.cu>0u; shared1.cu--) {	
		shared1.bu=a;							
		while(1) {
			while( ANDI_BUSY );
			ANDI_GO	// start conversion
			shared1.w.lu=ADRESL;
			shared1.w.hu=ADRESH;
			if(shared1.w.is > shared1.max) shared1.max=shared1.w.iu;
			if(shared1.w.is < shared1.min) shared1.min=shared1.w.iu;
			
			shared1.bu--;
			if(shared1.bu==0u) break;
		}
//		shared1.au+=(int)ADRESL;
//		shared1.au+=shared1.w.iu;
		shared1.dw.longu+=shared1.w.iu;
	}
	shared1.dw.longu>>=3;
}
//--------------------------------------------------------

